%define atilibdir	%{_libdir}/ati-fglrx
%define atilibdir32bit	%{_prefix}/lib/ati-fglrx

%{!?kversion: %define kversion `uname -r`}
BuildArchitectures: i586

Name:		xorg-x11-drv-fglrx
Version:	8.33.6
Release:	b2
Summary:	ATI proprietary driver for ATI Radeon graphic cards

Group:		User Interface/X Hardware Support
License:	Distributable
URL:		http://www.ati.com/support/drivers/linux/radeon-linux.html

Source0:	https://a248.e.akamai.net/f/674/9206/0/www2.ati.com/drivers/linux/ati-driver-installer-8.33.6-x86.x86_64.run
Source4:	ati-fglrx-fireglcontrol.desktop
Source12:	ati-fglrx.profile.d

Patch0:		ati-fglrx-panel_sources.diff
Patch1:		ati-fglrx-firegl_public_2.6.20.diff
Patch2:		ati-fglrx-via_int_agpgart.patch
Patch3:		ati-fglrx-firegl_public_2.6.23.diff

ExclusiveArch:	x86_64 i386

Obsoletes:	ati-fglrx

Requires(post):  chkconfig
Requires(post):  ldconfig
Requires(preun): chkconfig

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Conflicts:	fglrx
Conflicts:	nvidia-glx
Conflicts:	nvidia-glx-legacy

BuildRequires:  qt-devel, desktop-file-utils
BuildRequires:  mesa-libGLU-devel, mesa-libGL-devel, libXmu-devel, libXxf86vm-devel

%description
This package contains the X11 driver, utilities and libraries needed for the
ATI proprietary driver for ATI Radeon graphic cards.


%package devel
Summary:        ATI proprietary driver for ATI Radeon graphic cards, devel part
Group:		Development/Libraries

Requires:	%{name} = %{version}-%{release}
Requires:	%{_includedir}/X11/extensions, %{_includedir}/GL

%description devel
This package provides header files and examples required for development
for the ATI proprietary driver for ATI Radeon graphic cards.

%ifarch x86_64
%package libs-32bit
Summary:        32bit librarys for ATI's proprietary driver
Group:		User Interface/X Hardware Support
Requires:	%{name} = %{version}-%{release}

%description libs-32bit
This package contains the 32bit libraries of ATI's proprietary driver for
ATI Radeon graphic cards.
%endif


%prep
%setup -q -c -T
sh %{SOURCE0} --extract fglrx
tar -cjf fglrx-kmod-data-%{version}.tar.bz2 fglrx/ATI_LICENSE.TXT fglrx/common/*/modules/fglrx/ fglrx/arch/*/*/modules/fglrx/
mkdir fglrxpkg

%ifarch %{ix86}
cp -r fglrx/common/* fglrx/x690/* fglrx/arch/x86/* fglrxpkg/
%endif

%ifarch x86_64
cp -r fglrx/common/* fglrx/x690_64a/* fglrx/arch/x86_64/* fglrxpkg/
%endif

mkdir -p fglrx_panel_sources
pushd fglrx_panel_sources
tar -xzf ../fglrxpkg/usr/src/*/fglrx_panel_sources.tgz
%patch0 -p0 -b .patch0
# we want to strip the binary
sed -i 's|STRIP = strip|STRIP = @echo strip is disabled for:|' Makefile
# correct name
sed -i 's|BASENAME =  fireglcontrol|BASENAME =  fireglcontrolpanel|' Makefile
popd

pushd fglrxpkg/lib/modules/fglrx/build_mod/
%patch1 -p0 -b .patch1
%patch2 -p1 -b .patch2
%patch3 -p0 -b .patch3
popd


%build
[ -n "$QTDIR" ] || . %{_sysconfdir}/profile.d/qt.sh
pushd fglrx_panel_sources
make %{?_smp_mflags}
popd

# Module
#pushd nvidiapkg/
#%patch0
#popd
#sed -e 's/\$(MAKE) -C \$(KDIR) SUBDIRS=\$(PWD) modules/\$(MAKE) -C \$(KDIR) SUBDIRS=. modules/' -i fglrxpkg/lib/modules/fglrx/build_mod/2.6.x/Makefile
ksrc=/lib/modules/%{kversion}/build
pushd fglrxpkg/lib/modules/fglrx/build_mod/
    export AS_USER=y
    export KERNEL_PATH="${ksrc}"
    #export FEDORA_UNAME_R="%{kverrel}${kvariant:+-$kvariant}"
    #export FEDORA_UNAME_M="%{_target_cpu}"
    export CC="gcc"
    bash make.sh verbose
popd


%install
rm -rf $RPM_BUILD_ROOT ./__doc

find fglrxpkg/ -name "*.so*" | xargs strip --strip-unneeded

install -D -m 0644 fglrxpkg/lib/modules/fglrx/build_mod/2.6.x/fglrx.ko $RPM_BUILD_ROOT/lib/modules/%{kversion}/kernel/drivers/char/drm/fglrx.ko
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/kernel/drivers/char/drm/*

set +x
for file in $(cd fglrxpkg &> /dev/null; find . -type f | grep -v -e 'fireglcontrol.kdelnk$' -e 'fireglcontrol.desktop$' -e 'lib/modules/fglrx$' -e 'ati.xpm$' -e 'fireglcontrolpanel$' -e '/usr/share/doc/fglrx/' -e 'fglrx_panel_sources.tgz$' -e 'fireglcontrol_kde3.desktop$' -e 'fglrx_sample_source.tgz$' -e 'fglrx_sample_source.tgz$' -e '^./lib/modules/fglrx')
do
  if [[ ! "/${file##}" = "/${file}" ]]
  then
    install -D -p -m 0644 fglrxpkg/${file} ./__doc/${file##./usr/share/doc/fglrx/}
  elif [[ ! "/${file##./usr/X11R6/%{_lib}/modules}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/${file##./usr/X11R6/%{_lib}/modules}
  elif [[ ! "/${file##./usr/X11R6/lib/modules}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_prefix}/lib/xorg/modules/${file##./usr/X11R6/lib/modules}
  elif [[ ! "/${file##./usr/X11R6/include/X11/extensions}" = "/${file}" ]]
  then
    install -D -p -m 0644 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_includedir}/X11/extensions/${file##./usr/X11R6/include/X11/extensions}
  elif [[ ! "/${file##./usr/X11R6/%{_lib}/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{atilibdir}/${file##./usr/X11R6/%{_lib}/}
  elif [[ ! "/${file##./usr/X11R6/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{atilibdir32bit}/${file##./usr/X11R6/lib/}
  elif [[ ! "/${file##./usr/X11R6/bin/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_bindir}/${file##./usr/X11R6/bin/}
  elif [[ ! "/${file##./usr/bin/}" = "/${file}" ]]
  then
    install -D -p -m 0755 fglrxpkg/${file} $RPM_BUILD_ROOT/%{_bindir}/${file##./usr/bin/}
  elif [[ ! "/${file##./usr/include/}" = "/${file}" ]] || [[ ! "/${file##./etc/}" = "/${file}" ]] || [[ ! "/${file##./usr/share/man/}" = "/${file}" ]] || [[ ! "/${file##./usr/sbin/}" = "/${file}" ]]
  then
    install -D -p -m 0644 fglrxpkg/${file} $RPM_BUILD_ROOT/${file}
  else
    echo ${file} found -- don\'t know how to handle
    #exit 1
  fi
done
set -x

ln -s libfglrx_gamma.so.1.0 $RPM_BUILD_ROOT/%{atilibdir}/libfglrx_gamma.so.1
ln -s libfglrx_dm.so.1.0 $RPM_BUILD_ROOT/%{atilibdir}/libfglrx_dm.so.1
ln -s libfglrx_pp.so.1.0 $RPM_BUILD_ROOT/%{atilibdir}/libfglrx_pp.so.1
ln -s libGL.so.1.2 $RPM_BUILD_ROOT/%{atilibdir}/libGL.so.1

# workaround for modular X, part1
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri/
ln -s %{_libdir}/xorg/modules/dri/fglrx_dri.so $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri/fglrx_dri.so
#ln -s %{_libdir}/xorg/modules/dri/atiogl_a_dri.so $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri/atiogl_a_dri.so
#mkdir -p $RPM_BUILD_ROOT/usr/lib/dri/
#cp -a $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/dri/* $RPM_BUILD_ROOT/usr/lib/dri/

install -D -p -m 0644 fglrx_panel_sources/ati.xpm $RPM_BUILD_ROOT/%{_datadir}/pixmaps/ati.xpm
install -D -p -m 0755 fglrx_panel_sources/fireglcontrolpanel $RPM_BUILD_ROOT/%{_bindir}/fireglcontrolpanel
install -D -p -m 0755 %{SOURCE12} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/ati-fglrx.sh

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/
echo "disabled" > $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/ati-fglrx-config-display

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install --vendor berry \
    --dir $RPM_BUILD_ROOT%{_datadir}/applications \
    --add-category System \
    --add-category Application \
    --add-category KDE \
    --add-category Qt \
    %{SOURCE4}

# ld.so.conf.d file
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/
echo "%{atilibdir}" > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/ati-fglrx.conf


%clean
rm -rf $RPM_BUILD_ROOT


%post
/sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(644,root,root,755)
/lib/modules/*/kernel/drivers/char/drm/*
%defattr(-,root,root,-)
#%doc fglrxpkg/usr/share/doc/fglrx/*
%{_prefix}/X11R6
%{_datadir}/pixmaps/ati.xpm
%{_sysconfdir}/profile.d/ati-fglrx.sh
%{_sbindir}/atieventsd
%{_bindir}/aticonfig
%{_bindir}/fgl_glxgears
%{_bindir}/fglrxinfo
%{_bindir}/fglrx_xgamma
%{_bindir}/fireglcontrolpanel
%dir %{atilibdir}
#%{atilibdir}/libaticonfig.a
#%{atilibdir}/libfglrx_pp.*
#%{atilibdir}/libfglrx_dm.*
#%{atilibdir}/libfglrx_gamma.*
%{atilibdir}/libfglrx_pp.so.*
%{atilibdir}/libfglrx_dm.so.*
%{atilibdir}/libfglrx_gamma.so.*
%{atilibdir}/libfglrx_tvout.so.*
%{atilibdir}/libGL.so.*
%config %{_sysconfdir}/ati/fglrxrc
%config %{_sysconfdir}/ati/fglrxprofiles.csv
%{_libdir}/xorg/modules/drivers/fglrx_drv.so
%{_libdir}/xorg/modules/linux/libfglrxdrm.so
#%{_libdir}/xorg/modules/dri/atiogl_a_dri.so
%{_libdir}/xorg/modules/dri/fglrx_dri.so
%{_datadir}/applications/berry-ati-fglrx-fireglcontrol.desktop
#%{_libdir}/dri/atiogl_a_dri.so
#%{_libdir}/dri/fglrx_dri.so
#%{_sysconfdir}/ld.so.conf.d/ati-fglrx.conf

%files devel
%defattr(-,root,root,-)
%doc fglrxpkg/usr/src/*/fglrx_sample_source.tgz
%{_includedir}/GL/glxATI.h
%{_includedir}/GL/glATI.h
%{_includedir}/X11/extensions/fglrx_gamma.h

%ifarch x86_64
%files libs-32bit
%defattr(-,root,root,-)
%{atilibdir32bit}/
%endif
%ghost %{_sysconfdir}/sysconfig/ati-fglrx-config-display


%changelog
* Sun Jul 8 2007 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 8.33.6 (need Coreutils)
* Fri Oct 20 2006 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 8.29.6 for 2.6.18
* Thu May 18 2006 Yuichiro Nakada <berry@po.yui.mine.nu>
- Create for Berry Linux
